﻿local G, F, C, L = unpack(select(2,...))
local function TestFunc()
if AddUIDB.chatg ==  false  then return end

-- copy for NDui
local config = {enable = true,matches=1}
local msgSymbols = {"…","`", "～", "＠","@", "＃", "^", "＊","*", "！", "？", "。", "丨","|", " ", "—", "——", "￥", "’", "‘", "“", "”", "【", "】", "『", "』", "《", "》","·", "'","〈", "〉", "（", "）","%(", "%)", "〔", "〕", "、", "，", "：", ",", "_", "/", "~", "%-", "%.","一","%%","#","!"}
--关键词
local FilterList = {"1②","1⒉","2O","I2","｜2○","⒉0","二0","任意","二零",".业","有偿","wG","WG","W金","w{金}","速升","速成","1满","招收","备战","ll〇","买票","门票","强制","押金","老板","散拍","欢迎","付一","至满","加入","招募","老牌","诚招","公会","工会","详情","有位","安全","预订","5M10","活动时间","奥迪","奥地","有意者私M","奥底","带新","迪尔","PTH","HPT","英雄","同甲","120","桐甲","底保","戈霍恩",}
local updateFrame = CreateFrame("frame")
local function UnitInGuild(unitName)
for i = 1, GetNumGuildMembers() do
local name = GetGuildRosterInfo(i)
if name and name == unitName then
return true
end
end
return false
end
local friendsList = {}
local function updateFriends()
wipe(friendsList)

for i = 1, GetNumFriends() do
local name = GetFriendInfo(i)
if name then
friendsList[Ambiguate(name, "none")] = true
end
end

for i = 1, select(2, BNGetNumFriends()) do
for j = 1, BNGetNumFriendGameAccounts(i) do
local _, characterName, client, realmName = BNGetFriendGameAccountInfo(i, j)
if client == BNET_CLIENT_WOW then
friendsList[Ambiguate(characterName.."-"..realmName, "none")] = true
end
end
end
end

updateFrame:RegisterEvent("FRIENDLIST_UPDATE")
updateFrame:RegisterEvent("BN_FRIEND_INFO_CHANGED")
updateFrame:SetScript("OnEvent",updateFriends)

local function genChatFilter(_, event, msg, author, _, _, _, flag)
if not config.enable then return end

local name = Ambiguate(author, "none")
if UnitIsUnit(name, "player") or (event == "CHAT_MSG_WHISPER" and flag == "GM") or flag == "DEV" then
return
elseif UnitInGuild(author) or UnitInRaid(name) or UnitInParty(name) or friendsList[name] then
return
end

for _, symbol in ipairs(msgSymbols) do
msg = gsub(msg, symbol, "")
end

local match = 0
for _, keyword in pairs(FilterList) do
if keyword ~= "" then
local _, count = gsub(msg, keyword, "")
if count > 0 then
match = match + 1
end
end
end

if match >= config.matches then
return true
end
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", genChatFilter)
--ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", genChatFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", genChatFilter)
--ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", genChatFilter)
ChatFrame_AddMessageEventFilter("CHAT_MSG_EMOTE", genChatFilter)

end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)